package eu.univento.commons.database;

import com.mongodb.client.MongoDatabase;
import lombok.Getter;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.function.Consumer;

/**
 * @author joethei
 * @version 1.0
 */
public class AsyncMongoDB {

    @Getter private ExecutorService executor;
    @Getter private MongoDB mongoDB;

    public AsyncMongoDB(String host, int port, String user, String password, String database) {
        mongoDB = new MongoDB(host, port, user, password, database);
        executor = Executors.newCachedThreadPool();
    }

    public void getDatabase(Consumer<MongoDatabase> consumer) {
        consumer.accept(mongoDB.getDatabase());
    }

}