/*
 * Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.commons.player.rank;

import lombok.Getter;

/**
 * @author joethei
 * @version 2.0
 */

public enum Rank {

    Admin(18, 0, 0, Group.None, "a", "§4", "§8[§4Admin§8] §4", " §8»§7 ", "§4Admin | "),

    SrDeveloper(17, 0, 0, Group.Developer, "b"),
    Developer(16, 0, 0, Group.Developer, "c"),
    JrDeveloper(15, 0, 0, Group.Developer, "d"),

    SrBuilder(8, 0, 0, Group.Builder, "e"),
    Builder(7, 0, 0, Group.Builder, "f"),
    JrBuilder(6, 0, 0, Group.Builder, "g"),

    SrModerator(14, 0, 0, Group.Moderator, "h"),
    Moderator(13, 0, 0, Group.Moderator, "i"),
    JrModerator(12, 0, 0, Group.Moderator, "j"),

    SrSupporter(11, 0, 0, Group.Supporter, "k"),
    Supporter(10, 0, 0, Group.Supporter, "l"),
    JrSupporter(9, 0, 0, Group.Supporter, "m"),

    Graphic(5, 0, 0, Group.Design, "n"),
    Sound(4, 0, 0, Group.Design, "o"),

    VIP(3, 0, 0, Group.None, "p", "§5", "§5", " §8»§7 ", "§5"),
    Premium(2, 0, 0, Group.None, "q", "§6", "§6", " §8»§7 ", "§6"),
    Player(1, 0, 0, Group.None, "r","§7", "§7", " §8»§7 ", "§7");

    @Getter private final int value;
    @Getter private final int ts;
    @Getter private final int board;
    @Getter private final Group group;
    @Getter private final String team;

    private String color;
    private String prefix;
    private String suffix;
    private String tab;

    Rank(int value, int ts, int board, Group group, String team) {
        this.value = value;
        this.ts = ts;
        this.board = board;
        this.group = group;
        this.team = team;
    }

    Rank(int value, int ts, int board, Group group, String team, String color, String prefix, String suffix, String tab) {
        this.value = value;
        this.ts = ts;
        this.board = board;
        this.group = group;
        this.team = team;

        this.color = color;
        this.prefix = prefix;
        this.suffix = suffix;
        this.tab = tab;
    }

    public String getColor() {
        if(group == Group.None) return color;
        return group.getColor();
    }

    public String getPrefix() {
        if(group == Group.None) return prefix;
        return group.getPrefix();
    }

    public String getSuffix() {
        if(group == Group.None) return suffix;
        return group.getSuffix();
    }

    public String getTab() {
        if(group == Group.None) return tab;
        return group.getTab();
    }
}